public class Base64Decoder {

	private static byte decodemap[]=new byte[256];

	static {
		String encoded=
		"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
		byte in;

		/* Set all values to illegal! */
		for(int i=0;i<256;++i) {
			decodemap[i]=65;
		}
		/* Inverse map for quick lookup. */
		for(int i=0;i<encoded.length();++i) {
			decodemap[(byte)encoded.charAt(i)]=(byte)i;
		}	
		/* A different index. */
		decodemap['=']=64;
	}

	/* Returns the number of bytes output after decoding. 
	The input length is always a multiple of 4. The output
	length has no restriction. */
	public int decodeBytes(byte in[], int inputlen, byte out[]) {
		int outputlen=0;
		int inp=0;
		int ntimes=inputlen/4; /* If detecting irregular number of bytes, discard them. :-) */
		byte temp[]=new byte[4];
		for(int i=0;i<ntimes;++i) {
			
			/* Decode the existing code into numbers we can use. */
			temp[0]=decodemap[in[inp]  ];
			temp[1]=decodemap[in[inp+1]];
			temp[2]=decodemap[in[inp+2]];
			temp[3]=decodemap[in[inp+3]];

			if(temp[0]>=64||temp[1]>=64) {
			} else {
				out[outputlen]=(byte)( (temp[0]<<2)+((temp[1]&0x30)>>>4) ) ;
				/* Process trailing = */
				if(temp[2]>=64) {	
					outputlen+=1;
				} else {
					out[outputlen+1]=(byte)( ((temp[1]&0x0f)<<4)+((temp[2]&0x3c)>>>2) );
					/* Process trailing = */
					if(temp[3]>=64) {
						outputlen+=2;
					} else {
						out[outputlen+2]=(byte)( ((temp[2]&0x03)<<6)+temp[3] );
						outputlen+=3;
					}
				}
			}
			inp+=4;
		}
		return outputlen;
	}
}
